#!/usr/bin/python



#____________________________________________________________________________________
#
#    zodbPack (Pack the ZODB using a "standalone" script)
#    Copyright (C) 2002 Christoph Becker-Freyseng
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#    christoph@mmc-startup.com
#    http://www.beyond-thoughts.com
#    http://www.mmc-startup.com
#____________________________________________________________________________________
#


__version__='0.0'
__doc__="""Using this script you can pack a ZODB-file (Data.fs) without a running Zope-Server.
Zope however is required and you should only use this on a copy of your real Data.fs (a Zope-Server
should not access this ZODB-file while it is packed or copied). I've tested it and it wfm but please make a 
backup of your Data.fs .\n
Usage: zodbPack.py Data-copied.fs \n
and you've to configure some constants ... see below. Additionaly this script should run with the same
python version as your Zope-installation does.\n
( version 0.0 says 'nough :-) )\n"""


PATH_TO_ZOPES_PYTHON_MODULES= '/opt/Zope-2.4.1-linux2-x86/lib/python/'




import sys

sys.path.append(PATH_TO_ZOPES_PYTHON_MODULES)

if len(sys.argv)<2 or sys.argv[1][0]=='-':
    sys.stdout.write(__doc__)
    sys.exit(1)


import ZODB, ZODB.FileStorage


db= ZODB.DB(
	ZODB.FileStorage.FileStorage(
	    sys.argv[1]
	)
    )

root= db.open().root()
db.pack()
get_transaction().commit()
db.close()



